import re
import os
from string import strip, join, split, find

from OFS.Folder import Folder

from urllib import urlopen, quote, unquote

default_target = ''

protocol_pattern = re.compile('([^:]*:).*')
site_pattern = re.compile('([^:]*://[^/]*)/.*')
folder_pattern = re.compile('([^:]*://.*)/.*')

href_file_pattern = re.compile('(?i)(href\\s*=\\s*"*)([^:/"]+[^:"\\s]*"*)(?=[\\s>])')
href_path_pattern = re.compile('(?i)(href\\s*=\\s*"*)/([^"\\s]*"*)(?=[\\s>])')

src_file_pattern = re.compile('(?i)(src\\s*=\\s*"*)([^:/"]+[^:"\\s]*"*)(?=[\\s>])')
src_path_pattern = re.compile('(?i)(src\\s*=\\s*"*)/([^"\\s]*"*)(?=[\\s>])')

action_file_pattern = re.compile('(?i)(action\\s*=\\s*"*)([^:/"]+[^:"\\s]*"*)(?=[\\s>])')
action_path_pattern = re.compile('(?i)(action\\s*=\\s*"*)/([^"\\s]*"*)(?=[\\s>])')

form_pattern = re.compile('(?i)(<form\\s+[^>]*action\\s*=\\s*"*)([^"\\s>]*)("*[^>]*)(>)')
input_pattern = re.compile('(?i)(<input\\s+[^>]*name\\s*=\\s*"*)([^"\\s>]*"*[^>]*>)')

class lomMirror (Folder):
  meta_type = "lomMirror"
  description = "lomMirror"

  _properties = Folder._properties + (
     {'id':'categories', 'type':'lines', 'mode':'w'},)

  __ac_permissions__ = (
    ('View',
      ('Manager')),)

  #dtml_home = package_home (globals())


  exposable_methods = (
  )

  def __init__(self, id, target, lomPath):
    self.title = id + ' mirroring ' + target
    self.id = id
    self.categories = []
    if target[-1] == '/':
        self.targetURL = target
    else:
        self.targetURL = target, '/'
    self.a_tag_pattern = re.compile('(?i)(<a\\s+[^>]*href\\s*=\\s*"*)%s([^\?"\\s>]*)[^"\\s>]*("*[^>]*)(>)'%(self.targetURL))
    if lomPath[-1] != '/':
        lomPath = lomPath + '/'
    self.lom_path_pattern = lomPath + 'Concepts/manage_autoLinkForm?url=%s&text=&file='

  def index_html(self, REQUEST, RESPONSE, target=None):
    """
    Displays an external webpage annoated by Concepts/manage_autoLinkForm
    """

    if target is None:
      RESPONSE.redirect('%s?target=%s'%(self.absolute_url(), quote(default_target)))
      return ''
    return self.getContents(self.targetURL+target)

  def getContents(self,url,username="anonymous"):
    target_protocol,repl=protocol_pattern.subn('\\1', url)
    target_site,repl=site_pattern.subn('\\1', url)
    target_folder,repl=folder_pattern.subn('\\1', url)
    
    stream = urlopen(self.lom_path_pattern%(quote(url)), None)
    contents = stream.read()
    stream.close()
    contents = self.compelete_href(contents,target_protocol,target_site,target_folder)
    contents,repl = self.a_tag_pattern.subn('\\1%s?target=\\2\\3\\4'%(self.absolute_url()), contents)

    #contents,repl = input_pattern.subn('\\1'+changed_keys_prefix+'\\2',contents)
    #contents,repl = form_pattern.subn('\\1%s\\3\\4<input type="hidden" name="target" value=\\2>'%(self.containerURL), contents)

    return contents

  def compelete_href(self, html, url_protocol, url_site, url_path):
    contents,reps=href_file_pattern.subn('\\1'+url_path+'/\\2', html)
    contents,reps=src_file_pattern.subn('\\1'+url_path+'/\\2', contents)
    contents,reps=action_file_pattern.subn('\\1'+url_path+'/\\2', contents)
    contents,reps=href_path_pattern.subn('\\1'+url_site+'/\\2',contents)
    contents,reps=src_path_pattern.subn('\\1'+url_site+'/\\2',contents)
    contents,reps=action_path_pattern.subn('\\1'+url_site+'/\\2',contents)
    return contents

  def showContainerURL(self):
    """ for debugging """
    return '<html><body>containerURL=%s<br>absolute_url=%s</body></html>'%(self.containerURL,self.absolute_url())

def manage_addMirror(self, REQUEST, RESPONSE, id, target, lomPath):
    """ lomMirror constructor """
    obj = lomMirror(id, target, lomPath)
    siteId = self._setObject(id, obj)
    RESPONSE.redirect('../',id)
